
set more off, perm

cd "/disk/bulkw/zachward/cens1930.work/ImmigrantMulti/"

/*Data after merging with the 1910-1920 link.*/

use "data/robustcheck.dta", clear

foreach xvar in farmer wc skilled unskilled {
	gen mean`xvar'=(`xvar'1920+`xvar'_G21910)/2
}

foreach xvar in loccscore lsobekscore{
	gen raw`xvar'1910=exp(`xvar'_G21910)
	gen raw`xvar'1920=exp(`xvar'1920)
	gen mean`xvar'=log((raw`xvar'1910+raw`xvar'1920)/2)
}


/*Ensure regression sample is fixed*/

foreach xvar in farmer wc skilled unskilled loccscore lsobekscore {
	reg `xvar'_G31940 `xvar'_G21910 `xvar'CLPSDbar2 [pw=weight188019101940]
	drop if e(sample)==0
	reg `xvar'_G31940 mean`xvar' `xvar'CLPSDbar2 [pw=weight188019101940] 
	drop if e(sample)==0
}
 	
capture erase "tables/two_obs.xml"
capture erase "tables/two_obs.txt"
	
foreach xvar in farmer wc skilled unskilled loccscore lsobekscore {
	reg `xvar'_G31940 `xvar'_G21910 `xvar'CLPSDbar2 [pw=weight188019101940]
	lincom `xvar'_G21910+`xvar'CLPSDbar2
	outreg2 using "tables/two_obs", excel append noas dec(3) sortvar(`xvar'_G21910 `xvar'1920  mean`xvar' `xvar'CLPSDbar2) adds(joint,r(estimate), standarderror,r(se)) 
	reg `xvar'_G31940 `xvar'1920 `xvar'CLPSDbar2 [pw=weight188019101940]
	lincom `xvar'1920+`xvar'CLPSDbar2
	outreg2 using "tables/two_obs", excel append noas dec(3) sortvar(`xvar'_G21910  `xvar'1920 mean`xvar' `xvar'CLPSDbar2) adds(joint,r(estimate), standarderror,r(se)) 
	reg `xvar'_G31940 mean`xvar' `xvar'CLPSDbar2 [pw=weight188019101940] 
	lincom mean`xvar'+`xvar'CLPSDbar2
	outreg2 using "tables/two_obs", excel append  noas dec(3)  sortvar(`xvar'_G21910 `xvar'1920 mean`xvar' `xvar'CLPSDbar2) adds(joint,r(estimate), standarderror,r(se)) 
}

