/*Probit Modelling 1880-191*/

cd "/disk/bulkw/zachward/cens1930.work/ImmigrantMulti/builddata/"

use "data/19101920sample_link_white_ZW.dta", clear

capture rename namefrst1910 namefrst1910orig
capture rename namefrst1920 namefrst1920orig

capture gen namefrst1910=word(namefrst1910orig,1)
capture gen namefrst1920=word(namefrst1920orig,1)

replace namelast1920=upper(namelast1920)

gen exactlast=namelast1910==namelast1920
gen exactfirst=namefrst1910==namefrst1920
gen exactfirstlast=exactlast==1 & exactfirst==1

nysiis namelast1920, gen(nylast1920)
nysiis namelast1910, gen(nylast1910)
nysiis namefrst1910, gen(nyfirst1910)
nysiis namefrst1920, gen(nyfirst1920)

gen exactnyfirst=nyfirst1920==nyfirst1910
gen exactnylast=nylast1920==nylast1910
gen exactnyfirstlast=exactnyfirst==1 & exactnylast==1

foreach x of varlist namefrst1920 namefrst1910 namelast1910 namelast1920{
	gen `x'sdx=soundex_nara(`x')
}

gen exactsdxfirst=namefrst1920sdx==namefrst1910sdx
gen exactsdxlast=namelast1910sdx==namelast1920sdx
gen exactsdxfirstlast=exactsdxfirst==1 & exactsdxlast==1


foreach xvar of varlist exactlast exactfirstlast exactfirst ///
	exactsdxfirst exactsdxlast exactsdxfirstlast ///
	exactnyfirst exactnylast exactnyfirstlast {
	egen total`xvar'=total(`xvar'), by(serial1910 pernum1910)
	replace total`xvar'=2 if total`xvar'>=2
	gen unique`xvar'=total`xvar'==1 & `xvar'==1
}



gen nylnameyob0=exactnylast & yobdiff==0
gen nylnameyob1=exactnylast	& yobdiff==1
gen nylnameyob2=exactnylast	& yobdiff>=2

drop minitmatch
gen minitmatch=middleinit1910==middleinit1920 & length(middleinit1910)==1 ///
	& length(middleinit1920)==1

egen maxn=max(n), by(serial1910 pernum1910)
gen maxnsq=maxn^2
gen onematch=maxn==1

drop jwfirst*
jarowinkler namefrst1910 namefrst1920, gen(jwfirst)
gen jwfirstdist=1-jwfirst
gen lengthlast1910=length(namelast1910)
gen lengthlast1920=length(namelast1920)
gen absdifflength=abs(lengthlast1920-lengthlast1910)

gen mbplmatch=mbpl1910==mbpl1920
gen fbplmatch=fbpl1910==fbpl1920

probit link jwfirstdist jwlastdist i.yobdiff maxn maxnsq uniqueexactny* ///
	uniqueexactlast  ///
	minitmatch nylnameyob* i.totalexactnylast ///
	i.totalexactlast onematch absdifflength mbplmatch fbplmatch
	
outreg2 using "tables/probit19101920_white", replace excel
predict score19101920
gsort serial1910 pernum1910 -score19101920

by serial1910 pernum1910: gen n_=_n	
tab n_ if link==1	

capture drop maxscore maxlink 
egen double pid1910=group(serial1910 pernum1910)
egen maxscore=max(score19101920), by(pid1910)
egen maxlink=max(link), by(pid1910)

keep if n_==1 | n_==2
matrix tpr=J(1000,500,.)
matrix ppv=J(1000,500,.)

matrix rowname tpr=probability
matrix colname tpr=ratio

matrix rowname ppv=probability
matrix colname ppv=ratio

forvalues i=1/800{
	forvalues j=1/100{
		gen predictlink=(score19101920>=`i'/1000) & n_==1

		by serial1910 pernum1910: gen ratio=score19101920/score19101920[_n+1]

		replace predictlink=0 if ratio<=`j'/10

		gen tp=predictlink==1 & link==1
		gen fn=predictlink==0 & link==1
		gen fp=predictlink==1 & link==0
		replace tp =0 if n_==2
		replace fn=0 if n_==2
		replace fp=0 if n_==2

		egen totaltp=total(tp)
		egen totallink=total(link)
		gen tpr=totaltp/totallink

		egen totalfp=total(fp)

		gen ppvdenom=totaltp+totalfp

		gen ppv=totaltp/ppvdenom

		qui su ppv

		matrix ppv[`i',`j']=r(mean)
		qui su tpr
		matrix tpr[`i',`j']=r(mean)
		drop predictlink ratio tp fn fp totaltp totallink tpr totalfp ppvdenom ppv 
	}
}
mat2txt, matrix(ppv) saving(ppv1910_white) replace
mat2txt, matrix(tpr) saving(tpr1910_white) replace
