/*Probit Modelling 1880-191*/

cd "/disk/bulkw/zachward/cens1930.work/ImmigrantMulti/builddata/"

use "19101940handlinked.dta", clear

rename namefrst_gen41910 namefrst_gen41910orig
rename namefrst_gen41940 namefrst_gen41940orig

gen namefrst_gen41910=word(namefrst_gen41910orig,1)
gen namefrst_gen41940=word(namefrst_gen41940orig,1)

replace middleinit_gen41910=substr(word(namefrst_gen41910orig,2),1,1) ///
	if middleinit_gen41910=="" & length(word(namefrst_gen41910orig,2))>1

replace middleinit_gen41940=substr(word(namefrst_gen41940orig,2),1,1) ///
	if middleinit_gen41940=="" & length(word(namefrst_gen41940orig,2))>1	

gen minitmatch=middleinit_gen41910==middleinit_gen41940 & length(middleinit_gen41910)==1 ///
	& length(middleinit_gen41940)==1

replace namelast_gen41940=upper(namelast_gen41940)

gen exactlast=namelast_gen41910==namelast_gen41940
gen exactfirst=namefrst_gen41910==namefrst_gen41940
gen exactfirstlast=exactlast==1 & exactfirst==1

nysiis namelast_gen41940, gen(nylast1940)
nysiis namelast_gen41910, gen(nylast1910)
nysiis namefrst_gen41910, gen(nyfirst1910)
nysiis namefrst_gen41940, gen(nyfirst1940)

gen exactnyfirst=nyfirst1940==nyfirst1910
gen exactnylast=nylast1940==nylast1910
gen exactnyfirstlast=exactnyfirst==1 & exactnylast==1

foreach x of varlist namefrst_gen41940 namefrst_gen41910 namelast_gen41910 namelast_gen41940{
	gen `x'sdx=soundex_nara(`x')
}

gen exactsdxfirst=namefrst_gen41940sdx==namefrst_gen41910sdx
gen exactsdxlast=namelast_gen41910sdx==namelast_gen41940sdx
gen exactsdxfirstlast=exactsdxfirst==1 & exactsdxlast==1


foreach xvar of varlist exactlast exactfirstlast exactfirst ///
	exactsdxfirst exactsdxlast exactsdxfirstlast ///
	exactnyfirst exactnylast exactnyfirstlast {
	egen total`xvar'=total(`xvar'), by(serial_gen41910 pernum_gen41910)
	replace total`xvar'=2 if total`xvar'>=2
	gen unique`xvar'=total`xvar'==1 & `xvar'==1
}

gen nylnameyob0=exactnylast & yobdiff==0
gen nylnameyob1=exactnylast	& yobdiff==1
gen nylnameyob2=exactnylast	& yobdiff>=2

egen maxn=max(n), by(serial_gen41910 pernum_gen41910)
gen maxnsq=maxn^2
gen onematch=maxn==1

jarowinkler namefrst_gen41910 namefrst_gen41940, gen(jwfirst)
gen jwfirstdist=1-jwfirst

probit link jwfirstdist jwlastdist i.yobdiff maxn maxnsq unique* ///
	minitmatch nylnameyob* i.totalexactnylast ///
	i.totalexactlast onematch 
	
outreg2 using "probit19101940", replace excel
predict score19101940
gsort serial_gen41910 pernum_gen41910 -score19101940

by serial_gen41910 pernum_gen41910: gen n_=_n	
tab n_ if link==1	

capture drop maxscore maxlink 
egen maxscore=max(score19101940), by(pid_gen41910)
egen maxlink=max(link), by(pid_gen41910)

keep if n_==1 | n_==2
matrix tpr=J(1000,500,.)
matrix ppv=J(1000,500,.)

matrix rowname tpr=probability
matrix colname tpr=ratio

matrix rowname ppv=probability
matrix colname ppv=ratio

forvalues i=1/1000{
forvalues j=1/100{
gen predictlink=(score19101940>=`i'/1000) & n_==1

by serial_gen41910 pernum_gen41910: gen ratio=score19101940/score19101940[_n+1]

replace predictlink=0 if ratio<=`j'/10

gen tp=predictlink==1 & link==1
gen fn=predictlink==0 & link==1
gen fp=predictlink==1 & link==0
replace tp =0 if n_==2
replace fn=0 if n_==2
replace fp=0 if n_==2

egen totaltp=total(tp)
egen totallink=total(link)
gen tpr=totaltp/totallink

egen totalfp=total(fp)

gen ppvdenom=totaltp+totalfp

gen ppv=totaltp/ppvdenom

qui su ppv

matrix ppv[`i',`j']=r(mean)
qui su tpr
matrix tpr[`i',`j']=r(mean)
drop predictlink ratio tp fn fp totaltp totallink tpr totalfp ppvdenom ppv 
}
}
mat2txt, matrix(ppv) saving(ppv1910) replace
mat2txt, matrix(tpr) saving(tpr1910) replace
